TRUNCATE TABLE wus_syncupdates_cache
GO
IF (EXISTS (SELECT * FROM [sysobjects] WHERE [name] = 'wus_acquire_new_updates' AND [type] = 'P'))
              DROP PROCEDURE wus_acquire_new_updates
GO
SET QUOTED_IDENTIFIER ON
GO
SET ANSI_NULLS ON
GO
CREATE PROCEDURE wus_acquire_new_updates
                           @bTruncated BIT OUTPUT
AS SET NOCOUNT ON
              SET @bTruncated = 0;
              
    CREATE TABLE #tmp_acquire_new_updates_found(
            nId int PRIMARY KEY
    );
DECLARE @nMin INT;
DECLARE @nMax INT;
   
            
    IF (NOT EXISTS (SELECT * FROM #t_installed_non_leaf_update_ids))
   BEGIN
    
        IF (NOT EXISTS (SELECT * FROM #t_filter_category_ids))        
            INSERT INTO #tmp_acquire_new_updates_found
            SELECT DISTINCT TOP 100 t_main.nRevisionID
            FROM wusx_upd_revision AS t_main
            WHERE   t_main.bHasPrereq = 0 AND NOT EXISTS(SELECT * FROM #t_other_cached_update_ids WHERE #t_other_cached_update_ids.nId = t_main.nRevisionID)
            ORDER BY t_main.nRevisionID;
        ELSE
            INSERT INTO #tmp_acquire_new_updates_found
            SELECT DISTINCT TOP 100 t_main.nRevisionID
            FROM wusx_upd_revision AS t_main
            WHERE   t_main.bHasPrereq = 0 AND NOT EXISTS(SELECT * FROM #t_other_cached_update_ids WHERE #t_other_cached_update_ids.nId = t_main.nRevisionID) AND
                    (t_main.bLeaf = 0 OR t_main.nRevisionID IN (SELECT nRevisionID FROM wusx_disjunction WHERE nPrerequisiteRevisionID IN (SELECT nId FROM #t_filter_category_ids))
) 
            ORDER BY t_main.nRevisionID;       
    END
    ELSE
    BEGIN
                  DELETE FROM #tmp_wus_new_upd2
                  FROM #tmp_wus_new_upd2 
                      INNER JOIN #t_other_cached_update_ids 
                          ON #t_other_cached_update_ids.nId = #tmp_wus_new_upd2.nRevisionID;
                  DELETE FROM #tmp_wus_new_upd2
                  FROM #tmp_wus_new_upd2 
                      INNER JOIN #t_installed_non_leaf_update_ids 
                          ON #t_installed_non_leaf_update_ids.nId = #tmp_wus_new_upd2.nRevisionID;
        IF (EXISTS (SELECT * FROM #t_filter_category_ids))
        BEGIN
                      DELETE FROM #tmp_wus_new_upd2
                      FROM #tmp_wus_new_upd2 
                          INNER JOIN wusx_upd_revision AS t_main
                              ON #tmp_wus_new_upd2.nRevisionID = t_main.nRevisionID
            WHERE NOT (t_main.bLeaf = 0 OR t_main.nRevisionID IN (SELECT nRevisionID FROM wusx_disjunction WHERE nPrerequisiteRevisionID IN (SELECT nId FROM #t_filter_category_ids)) 
)
        END
                  INSERT INTO #tmp_acquire_new_updates_found
                  SELECT DISTINCT TOP 100 nRevisionID
                  FROM #tmp_wus_new_upd2
                  ORDER BY #tmp_wus_new_upd2.nRevisionID;
    END
    
    DECLARE @nCount INT;
    SELECT @nCount = COUNT(nId), @nMin = MIN(nId), @nMax = MAX(nId)
    FROM #tmp_acquire_new_updates_found;
    SELECT  #tmp_acquire_new_updates_found.nId      "nRevisionID",
            wusx_upd_revision.bLeaf                 "bLeaf",
            wus_upd_metadata.imgXmlFragment         "imgXmlFragmentCore",
            wusx_upd_revision.bBundle               "bBundle",
            wusx_upd_revision.tmLastChangeTime      "tmLastChangeTime",
            wusx_upd_revision.bNWReady              "bNWReady"
    FROM #tmp_acquire_new_updates_found 
            INNER JOIN wusx_upd_revision
                ON wusx_upd_revision.nRevisionID = #tmp_acquire_new_updates_found.nId AND 
                    wusx_upd_revision.nRevisionID BETWEEN @nMin AND @nMax
            LEFT OUTER JOIN wus_upd_metadata
                ON  wus_upd_metadata.nRevisionID = #tmp_acquire_new_updates_found.nId AND wus_upd_metadata.nFragmentType = 1  AND
                    wus_upd_metadata.nRevisionID BETWEEN @nMin AND @nMax
    ORDER BY #tmp_acquire_new_updates_found.nId; 
              if( @nCount = 100 )
                           SET @bTruncated = 1;
GO
SET QUOTED_IDENTIFIER OFF
GO
SET ANSI_NULLS ON
GO
