TRUNCATE TABLE wus_syncupdates_cache
GO

DROP PROCEDURE IF EXISTS wus_acquire_new_updates
GO

CREATE PROCEDURE `wus_acquire_new_updates` (
    OUT `__vtmp_bTruncated` BOOL)
BEGIN
    
    DECLARE __st_FETCH_STATUS INT;
    DECLARE `__vtmp_nMin` INT;
    DECLARE `__vtmp_nMax` INT;
    DECLARE `__vtmp_nCount` INT;
    DECLARE CONTINUE HANDLER FOR SQLSTATE '02000' SET __st_FETCH_STATUS = 1;

    SET `__vtmp_bTruncated` = 0 ; 
    DROP TEMPORARY TABLE IF EXISTS __ttmp_tmp_acquire_new_updates_found;
CREATE TEMPORARY TABLE IF NOT EXISTS `__ttmp_tmp_acquire_new_updates_found` (
    `nId` INT  PRIMARY KEY
)ENGINE=InnoDB DEFAULT CHARACTER SET `ascii` COLLATE `ascii_general_ci`; 
    DELETE FROM `__ttmp_tmp_acquire_new_updates_found`;
    IF (NOT EXISTS (SELECT *  FROM `__ttmp_t_installed_non_leaf_update_ids` )) THEN
        IF (NOT EXISTS (SELECT *  FROM `__ttmp_t_filter_category_ids` )) THEN
            INSERT INTO `__ttmp_tmp_acquire_new_updates_found` SELECT DISTINCT `t_main`.`nRevisionID`  FROM `wusx_upd_revision`  AS `t_main` WHERE `t_main`.`bHasPrereq` = 0 AND NOT EXISTS (SELECT *  FROM `__ttmp_t_other_cached_update_ids` WHERE `__ttmp_t_other_cached_update_ids`.`nId` = `t_main`.`nRevisionID` )ORDER BY `t_main`.`nRevisionID` LIMIT 100;
        ELSE
            INSERT INTO `__ttmp_tmp_acquire_new_updates_found` SELECT DISTINCT `t_main`.`nRevisionID`  FROM `wusx_upd_revision`  AS `t_main` WHERE `t_main`.`bHasPrereq` = 0 AND NOT EXISTS (SELECT *  FROM `__ttmp_t_other_cached_update_ids` WHERE `__ttmp_t_other_cached_update_ids`.`nId` = `t_main`.`nRevisionID` )AND (`t_main`.`bLeaf` = 0 OR `t_main`.`nRevisionID` IN  ( SELECT `nRevisionID`  FROM `wusx_disjunction` WHERE `nPrerequisiteRevisionID` IN  ( SELECT `nId`  FROM `__ttmp_t_filter_category_ids` ) ) )ORDER BY `t_main`.`nRevisionID` LIMIT 100;
        END IF;
    ELSE
        DELETE FROM `__ttmp_tmp_wus_new_upd2` USING `__ttmp_tmp_wus_new_upd2` INNER JOIN  `__ttmp_t_other_cached_update_ids` ON `__ttmp_t_other_cached_update_ids`.`nId` = `__ttmp_tmp_wus_new_upd2`.`nRevisionID` ;
        DELETE FROM `__ttmp_tmp_wus_new_upd2` USING `__ttmp_tmp_wus_new_upd2` INNER JOIN  `__ttmp_t_installed_non_leaf_update_ids` ON `__ttmp_t_installed_non_leaf_update_ids`.`nId` = `__ttmp_tmp_wus_new_upd2`.`nRevisionID` ;
        IF (EXISTS (SELECT *  FROM `__ttmp_t_filter_category_ids` )) THEN
            DELETE FROM `__ttmp_tmp_wus_new_upd2` USING `__ttmp_tmp_wus_new_upd2` INNER JOIN  `wusx_upd_revision`  AS `t_main` ON `__ttmp_tmp_wus_new_upd2`.`nRevisionID` = `t_main`.`nRevisionID` WHERE NOT (`t_main`.`bLeaf` = 0 OR `t_main`.`nRevisionID` IN  ( SELECT `nRevisionID`  FROM `wusx_disjunction` WHERE `nPrerequisiteRevisionID` IN  ( SELECT `nId`  FROM `__ttmp_t_filter_category_ids` ) ) );
        END IF;
        INSERT INTO `__ttmp_tmp_acquire_new_updates_found` SELECT DISTINCT `nRevisionID`  FROM `__ttmp_tmp_wus_new_upd2` ORDER BY `__ttmp_tmp_wus_new_upd2`.`nRevisionID` LIMIT 100;
    END IF;
    SELECT SQL_CALC_FOUND_ROWS COUNT( `nId` )  , MIN( `nId` )  , MAX( `nId` )  INTO `__vtmp_nCount` , `__vtmp_nMin` , `__vtmp_nMax` FROM `__ttmp_tmp_acquire_new_updates_found` LIMIT 1;
    SELECT `__ttmp_tmp_acquire_new_updates_found`.`nId`  AS `nRevisionID`  , `wusx_upd_revision`.`bLeaf`  AS `bLeaf`  , `wus_upd_metadata`.`imgXmlFragment`  AS `imgXmlFragmentCore`  , `wusx_upd_revision`.`bBundle`  AS `bBundle`  , `wusx_upd_revision`.`tmLastChangeTime`  AS `tmLastChangeTime`  , `wusx_upd_revision`.`bNWReady`  AS `bNWReady`  FROM `__ttmp_tmp_acquire_new_updates_found` INNER JOIN  `wusx_upd_revision` ON `wusx_upd_revision`.`nRevisionID` = `__ttmp_tmp_acquire_new_updates_found`.`nId` AND `wusx_upd_revision`.`nRevisionID` BETWEEN `__vtmp_nMin` AND `__vtmp_nMax` LEFT OUTER JOIN  `wus_upd_metadata` ON `wus_upd_metadata`.`nRevisionID` = `__ttmp_tmp_acquire_new_updates_found`.`nId` AND `wus_upd_metadata`.`nFragmentType` = 1 AND `wus_upd_metadata`.`nRevisionID` BETWEEN `__vtmp_nMin` AND `__vtmp_nMax` ORDER BY `__ttmp_tmp_acquire_new_updates_found`.`nId` ;
    IF (`__vtmp_nCount` = 100 ) THEN
        SET `__vtmp_bTruncated` = 1 ; 
    END IF;
    DROP TEMPORARY TABLE IF EXISTS `__ttmp_tmp_acquire_new_updates_found`;
END
GO
